
var cDataSeparator = " > ";
var cDataFile = "findupdate.dat";
var cReportFile = "report.html";
var cLogFile = "findupdate.log";
// FileSystemObject constants (http://msdn.microsoft.com/en-us/library/314cz14s%28VS.85%29.aspx)
var ForReading = 1, ForWriting = 2, ForAppending = 8;
var TristateUseDefault = -2, TristateTrue = -1, TristateFalse = 0;

var gaFindName, gaFindURL, gaFindRegExp, gaFindLastVal, gaFindLastDate, gaFindNewVal;

var goFSO, goXHTTP;

var gsLOG, giTraf = 0;

initObj();
readData();
findData();
saveData();
generateReport();

function initObj() {
    goFSO = new ActiveXObject("Scripting.FileSystemObject");
    if (!goFSO) {
        alert("'FileSystemObject' is not created...");
        WScript.Quit();
    }
    goXHTTP = new ActiveXObject("MSXML2.XMLHTTP");
    if (!goXHTTP) {
        alert("'XMLHTTP' is not created...");
        WScript.Quit();
    }
    gsLOG = "";
}

function readData() {

    // read last data
    var sBuf = new String(readFile(cDataFile));
    if (sBuf.length > 0) {
        var aBuf = sBuf.split("\r\n\r\n");
        gaFindName = new Array(aBuf.length);
        gaFindURL = new Array(aBuf.length);
        gaFindRegExp = new Array(aBuf.length);
        gaFindLastVal = new Array(aBuf.length);
        gaFindLastDate = new Array(aBuf.length);
        for (i = 0; i < aBuf.length; i++) {
            var aBuf1 = aBuf[i].split("\r\n");
            if (aBuf1.length > 2) {
                gaFindName[i] = aBuf1[0];
                gaFindURL[i] = aBuf1[1];
                gaFindRegExp[i] = aBuf1[2];
                gaFindLastVal[i] = ((aBuf1[3] != null) ? aBuf1[3] : "");
                gaFindLastDate[i] = ((aBuf1[4] != null) ? aBuf1[4] : "");
            }
        }
    }
}

function saveData() {
    var fUpdate = false;
    var sCont = new String();
    for (var i = 0; i < gaFindName.length; i++) {
        if (gaFindName[i] != null) {
            sCont += gaFindName[i];
        } else {
            sCont += " ";
        }
        sCont += "\r\n";
        if (gaFindURL[i] != null) {
            sCont += gaFindURL[i];
        } else {
            sCont += " ";
        }
        sCont += "\r\n";
        if (gaFindRegExp[i] != null) {
            sCont += gaFindRegExp[i];
        } else {
            sCont += " ";
        }
        sCont += "\r\n";
        if (gaFindNewVal[i][1] == 1) {
            fUpdate = true;
            sCont += gaFindNewVal[i][0] + "\r\n";
            sCont += getCurDate(); 
        } else {
            sCont += gaFindLastVal[i] + "\r\n";
            sCont += gaFindLastDate[i];
        }
        if (i < gaFindName.length - 1) {
            sCont += "\r\n\r\n";
        }
    }
    if(fUpdate) writeFile(cDataFile, sCont);
}

function findData() {
    var sLastURL = new String("");
    var sHTML = new String("");
    var sFindRes = new String("");
    gaFindNewVal = new Array(gaFindName.length);
    var iCntNewUpd = 0, iCntHTMLfail = 0, iCntNotFind = 0;
    var workTime = new Date().getTime();

    printLog("==========================================================");
    printLog("");
    for (var i = 0; i < gaFindName.length; i++) {
	    gaFindNewVal[i] = new Array(2);
        gaFindNewVal[i][0] = gaFindLastVal[i];
        gaFindNewVal[i][1] = 0;
        printLog(getCurTime() + " " + gaFindName[i]);
//        printLog("             " + gaFindURL[i]);
        if (gaFindURL[i].length > 0 && gaFindURL[i].toLocaleString() != sLastURL.toLocaleString()) {
            sHTML = readHTML(gaFindURL[i]);
            sLastURL = gaFindURL[i];
            if (sHTML.length > 0) {
                printLog("             page size: " + getSizeStr(sHTML.length));
                giTraf += sHTML.length;
            } else {
                iCntHTMLfail++;
                gaFindNewVal[i][1] = -1;
                printLog("         ... load HTML is failed ...");
            }
        }
        if (sHTML != null && sHTML.length > 0) {
            sFindRes = findExecut(sHTML, gaFindRegExp[i]);
            sFindRes = trim(sFindRes, " ");
            if (sFindRes.length > 0) {
                gaFindNewVal[i][0] = sFindRes;
            } else {
                iCntNotFind++;
                printLog("         ... data is not finding in HTML ...");
                gaFindNewVal[i][1] = -2;
            }
        }
        if (gaFindLastVal[i].toString().length > 0 || gaFindLastDate[i].toString().length > 0) {
			printLog("             last vers: " + gaFindLastVal[i] + " on " + gaFindLastDate[i]);
		}
        if (gaFindLastVal[i] != gaFindNewVal[i][0]) {
            iCntNewUpd++;
            gaFindNewVal[i][1] = 1;
            printLog("         !!! Find update - " + gaFindName[i] + " " + gaFindNewVal[i][0] + " !!!");
        }
        printLog("");
    }
    printLog("----------------------------------------------------------");
    printLog(getCurTime() + " Find update(s):      " + iCntNewUpd.toString());
    printLog("             Failed HTML loading: " + iCntHTMLfail.toString());
    printLog("             Data is not finding: " + iCntNotFind.toString());
    printLog("");
    printLog("             Total traffic:       " + getSizeStr(giTraf));
    printLog("             Work time:           " + parseWorkTime(new Date().getTime() - workTime));
    printLog("");
    printLog("==========================================================");
}

function readFile(sFile) {
    if (goFSO.FileExists(sFile)) {
        var oTF = goFSO.OpenTextFile(sFile, ForReading);
        var sCont = oTF.ReadAll();
        return sCont;
    }
    return "";
}

function writeFile(sFile, sCont) {
    var oTF = goFSO.CreateTextFile(sFile, true);
    oTF.Write(sCont);
    oTF.Close();
    return goFSO.GetAbsolutePathName(sFile);
}

function getContSize(sCont) {
    sFile = "page.htm" 
    if (sCont.length > 0) {
        writeFile(sFile, sCont);
        if (goFSO.FileExists(sFile)) {
            return goFSO.GetFile(sFile).Size;
        }
    }
    return 0;
}

function readHTML(sURL) {
    try {
        goXHTTP.open("GET", sURL, false);
        goXHTTP.send();
        if (goXHTTP.Status == 200) {
            return goXHTTP.responseText;
        }
    } catch (e) {
        //            return e;
    }
    return "";
}

function findExecut(sSrc, sRegExp) {
    // http://javascript.ru/RegExp
    var oRE = new RegExp(sRegExp, "im");
    var aRes = oRE.exec(sSrc);
    var sRes = "";
    if (aRes) {
        if (aRes.length > 1) {
            for (var i = 1; i < aRes.length; i++) {
                if (sRes.length > 0) sRes += cDataSeparator;
                sRes += aRes[i];
            }
        } else {
            sRes = aRes[0];
        }
    }
    return sRes;
}

function trim(str, charlist) {
    // Strip whitespace (or other characters) from the beginning and end of a string
    // +   original by: Ilia Kantor (http://javascript.ru)
    charlist = !charlist ? ' \s\xA0' : charlist.replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g, '\$1');
    var re = new RegExp('^[' + charlist + ']+|[' + charlist + ']+$', 'g');
    return str.replace(re, '');
}

function printLog(sLog) {
    WScript.Echo(sLog);
    gsLOG += sLog + "\r\n";
}

function generateReport() {
    var fUpdate = false;
    var sHTML = new String("");
    var sHTML1 = new String("");
    var sHTMLTitle = new String("");
    sHTML = "<!DOCTYPE html PUBLIC \'-//W3C//DTD XHTML 1.0 Transitional//EN\' \'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\'>";
    sHTML += "\r\n<html xmlns=\'http://www.w3.org/1999/xhtml\'>";
    sHTML += "\r\n<head><meta http-equiv=\'content-type\' content=\'text/html; charset=windows-1251\' />";
    for (var i = 0; i < gaFindNewVal.length; i++) {
        if(gaFindNewVal[i][1] != 0) {
			var en = "";
			if (gaFindNewVal[i][1] == -1) {
				en += "<span style='color: red;'>Load HTML is failed: </span>";
				sHTMLTitle = genRepTitle(sHTMLTitle, gaFindNewVal[i][1]);
			} else if (gaFindNewVal[i][1] == -2) {
				en += "<span style='color: red;'>Data is not finding in HTML: </span>";
				sHTMLTitle = genRepTitle(sHTMLTitle, gaFindNewVal[i][1]);
			} else if (gaFindNewVal[i][1] == 1) {
				en += "<span style='color: green;'>Find update: </span>";
				sHTMLTitle = genRepTitle(sHTMLTitle, gaFindNewVal[i][1]);
			}
            sHTML1 += "\r\n<p>" + en
				+ "<a target=\'_blank' href=\'" 
            	+ gaFindURL[i] + "\'>" 
            	+ gaFindName[i] + " " 
            	+ gaFindNewVal[i][0] + "</a></p>";
            fUpdate = true;
        }
    }
    if (fUpdate) {
		sHTML += "\r\n<title>" + sHTMLTitle + "</title></head>\r\n<body>" + sHTML1 + "\r\n</body></html>";
		shellInetLnk(writeFile(cReportFile, sHTML));
	}
    writeFile(cLogFile, gsLOG);
}

function genRepTitle(sTit, bMode) {
	var sRez = new String("");
	if (bMode == -1 || bMode == -2) {
		sRez = "Data is lost";
	} else if (bMode == 1) {
		sRez = "Updates is available"
	}
	if (sTit.toString().length > 0) {
		if (sTit.indexOf(sRez) == -1) {
			sRez = sTit + " and " + sRez;
		} else {
			sRez = sTit;
		}
	}
	return sRez;
}

function shellInetLnk(sURL) {
    var objShell = new ActiveXObject("WScript.Shell");
    objShell.Run("iexplore.exe " + sURL);
}

function getCurTime() {
    var now = new Date();
    var hours = now.getHours();
    var minutes = now.getMinutes();
    var seconds = now.getSeconds();
    var millisec = now.getMilliseconds();
    var sTime = new String();
    sTime = ((hours < 10) ? "0" : "") + hours;
    sTime += ((minutes < 10) ? ":0" : ":") + minutes;
    sTime += ((seconds < 10) ? ":0" : ":") + seconds;
    sTime += "." ;
    if(millisec < 10) {
        sTime += "00";
    } else if(millisec < 100) {
        sTime += "0";    
    } 
    sTime += millisec;
    return sTime;
}

function parseWorkTime(workTime) {
    var seconds = Math.floor(workTime / 1000);
    var millisec = workTime - seconds * 1000;
    var sTime = new String(seconds);
//    sTime += ((seconds < 10) ? "0" : ":") + seconds;
    sTime += ".";
    if(millisec < 10) {
        sTime += "00";
    } else if(millisec < 100) {
        sTime += "0";
    }
    sTime += millisec + "s";
    return sTime;
}

function getCurDate() {
    var now = new Date();
    var day = now.getDate();
    var month = now.getMonth() + 1;
    var year = now.getFullYear();
    var sDate = new String();
    sDate = ((day < 10) ? "0" : "") + day;
    sDate += ((month < 10) ? ".0" : ".") + month;
    sDate += "." + year.toString().substring(2);
    return sDate;
}

function getSizeStr(iByte) {
    var iRez = iByte;
    var sVal = "B";
    if (iRez > 1024) {
        sVal = "K";
        iRez = iRez / 1024;
    }
    if (iRez > 1024) {
        sVal = "M";
        iRez = iRez / 1024;
    }
    var iPos = iRez.toString().indexOf(".");
    if (iPos > 0 && iPos + 3 < iRez.toString().length) {
        iRez = iRez.toString().substring(0, (iPos + 3)); 
    }
    return iRez.toString() + sVal; 
}
